#!/usr/bin/perl
#
#    Quality of Service Webmin Module
#    Copyright (C) 2001 by Level 7 Software
#
#    Author: Dan Damian <dand@level7.ro>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

require './cbq-lib.pl';

&ReadParse();

$action = defined($in{'classid'}) ?  'Editing' :  'New';

&new_class() if (defined($in{'new_class'}));
&save_class() if (defined($in{'action'}));
$c = &load_class($in{'classid'});

&header("Class $c->{'classname'}" , undef, undef, 1, undef, undef, "$header_note $website_link");
print "<hr>\n";

print "<form name=fm action=\"edit_class.cgi\">",
    "<input type=hidden name=\"action\" value=\"save\">",
    "<input type=hidden name=\"old_classid\" value=\"$in{'classid'}\">",
    "<input type=hidden name=\"rdelete\" value=\"\">",
    "<input type=hidden name=\"rnew\" value=\"\">";

print "<table cellpadding=4 border width=100%>\n",
    "<tr $tb><th>$action class $c->{'classname'}</th></tr><tr $cb><td align=center>",
    
    "<table cellpadding=4 cellspacing=0 border=0><tr><td valign=top>",
    "<table cellpadding=2 cellspacing=0 border=0>";
    
print "<tr><td align=right>Class ID:</td><td><input type=text name=\"classid\" value=\"$c->{'classid'}\" size=10></td></tr>";
    
print "<tr><td align=right>Class Name:</td><td><input type=text name=\"classname\" value=\"$c->{'classname'}\" size=10></td></tr>";
    
print "<tr><td align=right>Parent:</td><td><select name=\"parent\">";
print "<option value=\"\">&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;  &nbsp; </option>";
@classes = &parse_config_dir();
foreach $cls (@classes) {
    next if ($cls->{'classid'} eq $c->{'classid'});
    print "<option value=\"" . $cls->{'classid'} . "\"";
    print " selected " if ($c->{'parent'} eq $cls->{'classid'});
    print ">" . $cls->{'classname'} . "</option>";
}
print "</select></td></tr>";

print "<tr><td align=right>Rate (limit):</td><td><input type=text name=\"rate\" value=\"$c->{'rate'}\" size=10></td></tr>",
    "<tr><td colspan=2 align=right valign=top height=30>",
    "<input type=checkbox name=\"bounded\"", $c->{'bounded'} ne "no" ? " checked" : "", "> Bounded &nbsp; ",
    "<input type=checkbox name=\"isolated\"", $c->{'isolated'} eq "yes" ? " checked" : "", "> Isolated",
    
    "</td></tr>";

print "<tr><td align=right>Priority:</td><td><select name=\"prio\">";
&select_list ($c->{'prio'}, 1, 2, 3, 4, 5, 6, 7, 8);
print "</select></td></tr>";

print "<tr><td align=right>Interface:</td><td><select name=\"ifname\">";
&select_list($c->{'ifname'}, &active_interfaces());
print "</select></td></tr>";

print "<tr><td align=right>Bandwidth: </td><td><select name=\"bandwidth\">";
&select_list($c->{'bandwidth'}, "2Mbit", "10Mbit", "100Mbit");
print "</select></td></tr></table></td><td width=10>&nbsp;</td>";

print "<td valign=top>Active rules:<br><select name=rselect size=10 style=\"width:140px\" onChange=\"document.fm.rdelete.value = this.options[this.selectedIndex].value;\">";
&rules_list("rules");
print"</select></td>";

print "<td align=center>",    
    "<a href=\"javascript: var uinput = prompt('New Rule:', ''); if (uinput != '' && uinput != null) {document.fm.action.value='add'; document.fm.rnew.value=uinput; document.fm.submit();};\"><img src=\"images/a_new.gif\" border=0\"></a><p>",
    "<a href=\"javascript:document.fm.action.value='activate'; document.fm.submit();\"><img src=\"images/a_left.gif\" border=0\"></a> &nbsp; ",
    "<a href=\"javascript:document.fm.action.value='inactivate'; document.fm.submit();\"><img src=\"images/a_right.gif\" border=0></a><p>",
    "<a href=\"javascript: if (document.fm.rdelete.value) if (confirm('Really delete rule ' + document.fm.rdelete.value + '?')) { document.fm.action.value='delete'; document.fm.submit(); }\"><img src=\"images/a_delete.gif\" border=0\"></a></td>";

print "<td valign=top>Inactive rules:<br><select name=irselect size=10 style=\"width:140px\" onChange=\"document.fm.rdelete.value = this.options[this.selectedIndex].value;\">";
&rules_list("inactive_rules");
print "</select></td></tr>";

print "</table><p>";

print "<table cellpadding=0 cellspacing=0 width=400><tr><td align=center width=50% valign=top><input type=submit value=\"Save Class\"></form></td>",

    "<td align=center width=50% valign=top><form action=\"edit_file.cgi\"><input type=hidden name=classid  value=\"$in{'classid'}\"> <input type=submit value=\" Edit Source \"></form></td>",
    "</tr></table></td></tr></table></form><p>\n";


&footer("index.cgi", "index");

### END of index.cgi ###.
