#!/usr/bin/perl
#
#    Quality of Service Webmin Module
#    Copyright (C) 2001 by Level 7 Software
#
#    Author: Dan Damian <dand@level7.ro>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

require './qos-lib.pl';

if ($in{'classid'} =~ /[0-9]+/) { $action = "Edit" } else { $action = "New"};

&header($action . " Class", "", "index", 1, 1, 0);

print "<hr>\n";

$c = &load_class($in{'classid'}, $in{'classname'});
if (0) {
    print "ERROR: Could not load class " .  $in{'classname'} . " $c.<p>";
    &footer("index.cgi", "Index");
    exit;
}

@if_list = &active_interfaces();

print "<table cellpadding=4 border width=100%>\n";
print "<tr $tb><th>$action class " . $in{'classname'} . "</th></tr>";
print "<form action=\"edit_class.cgi\"><tr $cb><td align=center>";

print "<table cellpadding=4 cellspacing=0 border=0><tr><td>";
print "<table cellpadding=2 cellspacing=0 border=0>";

print "<tr><td align=right>Class Name:</td><td><input type=text name=\"classname\" value=\"$c->{'classname'}\" size=10></td></tr>";

print "<tr><td align=right>Rate (limit):</td><td><input type=text name=\"rate\" value=\"$c->{'rate'}\" size=10></td></tr>";
print "<tr><td colspan=2 align=right>";
print "<input type=checkbox name=\"bounded\""; print " checked" if ($c->{'bounded'} ne "no"); print "> Bounded &nbsp; ";
print "<input type=checkbox name=\"isolated\""; print " checked" if ($c->{'isolated'} eq "yes"); print "> Isolated";

print "</td></tr>";

print "<tr><td align=right>Priority:</td><td><select name=\"prio\">";
for (my $i = 1; $i <= 8; $i++) {
    print "<option name=\"$i\"";
    print " selected" if ($i eq $c->{'prio'});
    print ">$i</option>";
}
print "</select></td></tr>";

print "<tr><td align=right>Class ID:</td><td><input type=text name=\"classid\" value=\"$c->{'classid'}\" size=10></td></tr>";

print "<tr><td align=right>Parent:</td><td><input type=text name=\"parent\" value=\"$c->{'parent'}\" size=10></td></tr>";

print "<tr><td align=right>Interface:</td><td><select name=\"ifname\">";
foreach $ifname (@if_list) {
    print "<option name=\"$ifname\"";
    print " selected" if ($ifname eq $c->{'ifname'});
    print ">$ifname</option>";
}
print "</select></td></tr>";

print "<tr><td align=right>Bandwidth: </td><td><select name=\"bandwidth\">";
print "<option value=\"2Mbit\""; print " selected" if ($c->{'bandwidth'} eq "2Mbit"); print ">2Mbit";
print "<option value=\"10Mbit\""; print " selected" if ($c->{'bandwidth'} eq "10Mbit"); print ">10Mbit";
print "<option value=\"100Mbit\""; print " selected" if ($c->{'bandwidth'} eq "100Mbit"); print ">100Mbit";
print "</select></td></tr>";

print "</table></td><td valign=top>";

print "Active rules:<br><select size=12>";

$rule_list = $c->{'rules'};

my $i = 0;
foreach $rule (@$rule_list) {
    print "<option>$rule<br>";
}

print"</select></td>";

print "<td align=center><img src=\"images/a_up.gif\"><br><img src=\"images/a_left.gif\"><img src=\"images/dot.gif\" width=16 height=1><img src=\"images/a_right.gif\"><br><img src=\"images/a_down.gif\"></td>";

print "<td valign=top>Inactive rules:<br><select size=12></select></td></tr></table>";
print "<p><center><input type=submit value=\"Save class\"></center>";
print "</td></tr></form></table><p>\n";


&footer("index.cgi", "class list");

### END of index.cgi ###.
